#. author : Roland Frank
#. project: taifon Android app
#. license: GPLv3, see https://gnu.org/licenses
#.








if {![string length [info commands lcp]]} {
	proc lcp {a b} {
		return [gcp $a $b]
	}
}

proc tx_list {sorted_name first last fh discriminating {use 0}} {
	upvar $sorted_name k
	upvar $discriminating steps
	incr ::txlev

	set debug 0
	if {$debug || $::txlev>64} {
		set debug 1
		if {$::txlev>=64} {
			incr ::txlev -1
			incr ::skips
			puts $::txlev
		}
	}

	set mx ""
	set pre ""
	set pre_len 0

	if {$debug} {puts DEBUG-ON}

	if {$last>1} {
		set pre [lcp  [lindex $k $first] [lindex $k [expr {$last-1}]]]






		set spos [string length $pre]
		lappend steps $spos
		set res [list]
		if {[string equal $pre [lindex $k $first]]} {
			incr spos -1
			if {$debug} {
				set ddlast [string range $pre $spos $spos]
			}
			lappend res 1\v

		}
		set pre_len [string length $pre]
		set prev -1


		set probe 0
		set cp_first $first
		set cp_last $last


		for {set low $first} {$low<$last} {set low $probe} {
			set k_w [lindex $k $low]








			set t [string range $k_w $pre_len $pre_len]
			set i [nextchar $t]
			set next $pre$i
			set probe [nbr $next k $low $last]
			if {$probe>$last} {
				set probe $last
			}
			set prev $low
			if {$low==$probe-1} {
				set full 1
				set test [string range $k_w $pre_len end]
				if {[string length $test] == 0} {
					set full 2
					set bigger [string range [lindex $k $probe] $pre_len $pre_len]
					scan $bigger %c i
				} else {
					lappend res [format "%d\v%s" $full $test]
					set ::dchar([string range $test 0 0]) {}

				}
			} else {
				set full 0
			}

			if {$full<2} {
				if {$probe>$low+1} {

					set nextpre [tx_list k $low $probe $fh steps $use]

					set r [string range $nextpre $pre_len end]


					if {![string length $r]} {
						set epos [lindex $steps end]

						set r [string range $k_w $epos end]
					}

					lappend res [format "%d\v%s" $full $r]
					set ::dchar([string range $r 0 0]) {}

				} else {
					if {[llength $res]==0} {
						set k_element [lindex $k $probe]
						set dc [string range $k_element $pre_len end]


						lappend res [format %d\v%s $full $dc]
						set ::dchar([string range $dc 0 0]) {}
						incr probe 1
					}
				}
			}

		}

		set steps [lreplace $steps end end]

		if {$probe==0} {
			set probe [expr {$low+1}]
		}
		set y [llength $res]
		set mx [string range $pre $pre_len end]
		set mxlen [string length $mx]
		append mx \r
		append mx [join $res \n]
		set cp_pat {[\r\n]1\v}
		set ncp [regexp -all $cp_pat $mx]
		set ncp 21
		if {$last-$first<$ncp} {
			set more [list]
			foreach fin [lrange $k $first [expr {$last-1}]] {
				set tail [string range $fin $pre_len end]
				if {[string length $tail]} {
					set fintail 1\v$tail
					if {[lsearch $res $fintail]==-1} {
						lappend more $fin
					}
				}
			}
			if {[llength $more]} {
				append mx \r
				set lmx [list]
				foreach mm $more {
					lappend lmx [string range $mm $pre_len end]
				}
				append mx [join $lmx \n]
			}
		}

	} elseif {$last==1} {
		set k_w [lindex $k $first]
		set pre_len 0
		set  mx [string range $k_w $pre_len end]
		append mx \r

	}

	if {$use} {
		set short ""
		foreach n $steps {
			append short [string range $k_w $n $n]
		}
		puts $fh "[list [json_string $short]] [json_string $mx]"
	} else {
		puts $fh "[list [json_string $pre]] [json_string $mx]"
	}
	incr ::txlev -1

	return $pre
}

#. vi:noexpandtab:ts=4:sw=4:notx
